
 /**
  * Include files
  */
#include "ti/transport/ndk/nimu/example/ftpApp/modules.h"

#ifdef FTP_SERVER_MODULE_INCLUDED

#include <ti/csl/csl_error.h>
#include <ti/fs/fatfs/ff.h>
#include <ti/transport/ndk/nimu/example/ftpApp/ftpserver/ftpserver.h>

int32_t ftp_filerout_read(io_handler_t *ioh, char *path)
{
    int32_t i;
    FRESULT errCode;
    FIL file;
    DIR dir;
    UINT br;
    FILINFO fno;
    char filename[256];
    int len;
    char *buffer;

    len = strlen(ioh->current_working_dir_path);
    strncpy(filename, ioh->current_working_dir_path, 256);

    if(0 == len)
    {
        filename[0] = '\\';
        strncpy(&filename[1], path, 256-1);
    }
    else if(1 == len)
    {
        strncpy(&filename[1], path, 256-1);
    }
    else
    {
        if('\\' == filename[len-1])
        {
            strncpy(&filename[len], path, 256-len);
        }
        else
        {
            filename[len] = '\\';
            strncpy(&filename[len+1], path, 256-len-1);
        }
    }

    errCode = f_open(&file, filename, FA_OPEN_EXISTING | FA_READ);
    if(errCode != FR_OK)
    {
        return CSL_ESYS_FAIL;
    }

    if ((buffer = malloc (16384)) == NULL)
    {
        return CSL_ESYS_FAIL;
    }

    while(1)
    {
        //errCode = 0;
        //br = 16384;
        errCode = f_read(&file, buffer, 16384, &br);           /* Read data from a file */
        if(errCode != FR_OK)
        {
            f_close(&file);
            free (buffer);
            return CSL_ESYS_FAIL;
        }
        else if((EOF == br) || (0 == br))
        {
            f_close(&file);
            free (buffer);
            return CSL_SOK;
        }
        else
        {
            send(ioh->data_socket, buffer, br, 0);
        }
    }

//    for (i=0; i<5000;i++)
//    {
//        send(ioh->data_socket, ioh->DataBuf, DATA_BUFFER_SIZE, 0);
//        Task_yield();
//    }

    if(buffer != NULL)
    {
        free (buffer);
    }
    return CSL_SOK;
}

int32_t ftp_filerout_write(io_handler_t *ioh, char *path)
{
    int32_t bytesRead = 0;
    char *pBuf;
    void* hBuffer;

//    do
//    {
//        bytesRead = (int)recvnc(ioh->data_socket, (void**)&pBuf, 0, &hBuffer);
//
//        if (bytesRead > 0)
//        {
//            recvncfree(hBuffer);
//        }
//    } while (bytesRead > 0);

    return 0;
}

#endif
