/*
 * workflow.c
 *
 */

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <xdc/std.h>
#include <xdc/runtime/Error.h>
#include <xdc/runtime/System.h>
#include <xdc/runtime/Timestamp.h>
#include <xdc/runtime/Memory.h>
#include <xdc/runtime/Types.h>
#include <ti/ndk/inc/netmain.h>
#include <ti/ndk/inc/_stack.h>
#include <ti/sysbios/BIOS.h>
#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Semaphore.h>
#include <ti/sysbios/knl/Mailbox.h>
#include <ti/sysbios/hal/Hwi.h>
#include <ti/sysbios/family/arm/arm9/Cache.h>
#include <ti/fs/fatfs/diskio.h>
#include <ti/fs/fatfs/FATFS.h>

#include "uppTransmit.h"
#include "workflow.h"
#include "hw_types.h"
//#include "IICCmd.h"

#include "hw_types.h"                // 
#include "hw_syscfg0_C6748.h"        // ϵͳģĴ
#include "soc_C6748.h"               // DSP C6748 Ĵ

#pragma pack(4)

extern FATFS_Handle fatfsHandle;

AD_Ten_Frame ad_ten_frame_data_arm;
//#pragma DATA_ALIGN(ad_ten_frame_data_arm, 64)
#pragma DATA_SECTION(ad_ten_frame_data_arm, "User_sect");

int g_fileRecord 	 = 0;

unsigned int g_pingNum = 0;

char recordFileName[10];

int Ping_Num_Read = 0;

void taskWorkFlow(UArg arg0, UArg arg1)
{
    unsigned int   Sampling_Num = 0;
    unsigned int   line_count = 0;
    unsigned short B_para = 0;
    unsigned short C_para = 0;
    unsigned short D_para = 0;
    unsigned short F_para = 10;
    unsigned short G_para = 0;

    FIL 	file;
    UINT 	bw, br;
    FRESULT errCode;


    int i = 0;

    Task_sleep(15000);

    memset(recordFileName, 0, sizeof(recordFileName));
    recordFileName[0] = '3';
    recordFileName[1] = '2';
    recordFileName[2] = '.';
    recordFileName[3] = 'D';
    recordFileName[4] = 'A';
    recordFileName[5] = 'T';
    recordFileName[6] = 0x0d;
    g_fileRecord = 1;

    if(1 == g_fileRecord)
     {
		 errCode = f_open(&file, recordFileName, FA_CREATE_ALWAYS | FA_WRITE);
		 if(errCode != FR_OK)
		 {
			g_fileRecord = 0;
		 }
     }

    while(1)
    {
        line_count = 10;

        g_pingNum++;
        if(g_pingNum == 10)
        {
        	g_fileRecord = 0;
        }

		if(1 == g_fileRecord)
		{
			errCode = f_write (&file, (void *)(&ad_ten_frame_data_arm.frame_data[0].header), sizeof(AD_One_Frame_Header) + upp_line_size * line_count, &bw);    /* Write data to a file */
			if(errCode != FR_OK)
			{
				f_close (&file);
				g_fileRecord = 0;
				sprintf("::::Write data to SD card error, stop recording! Write Byte\r\n", bw);
			}
		}

		if(g_fileRecord == 0)
		{
			f_close (&file);
		}
	    // SD洢ݶȡ
		#if 0
			if(Ping_Num_Read == 0)
			{
				errCode = f_open(&file, "70303.DAT", FA_OPEN_ALWAYS | FA_READ | FA_WRITE);
				if(errCode != FR_OK)
				{
					sprintf(msg_PingLost, "::::Open file error! Exit.\r\n");
					continue;
				}
				else
				{
					Ping_Num_Read = 1;
				}
			}

			if(f_eof(&file) == 0)
			{
				//ȡͷ
				errCode = f_read(&file, (void *)(&ad_ten_frame_data_arm.frame_data[0].header), sizeof(AD_One_Frame_Header), &br);
				if(errCode != FR_OK)
				{
					sprintf(msg_PingLost, "::::Open file header error! Exit.\r\n");
					continue;
				}
				//ȡ
				errCode = f_read(&file, (void *)(&ad_ten_frame_data_arm.frame_data[0].data), upp_line_size * line_count, &br);
				if(errCode != FR_OK)
				{
					sprintf(msg_PingLost, "::::Open file data error! Exit.\r\n");
					continue;
				}
			}
			else
			{
				f_close (&file);
				sprintf(msg_PingLost, "::::Close file! Exit.\r\n");
				continue;
			}

		#endif

		Task_sleep(1);

    }
}

